#import "TempoTestPlugin.h"

static NSString *const kGetPlatformVersion = @"getPlatformVersion";

static NSString *const kGetAppVersion = @"getAppVersion";

static NSString *const kRouteNative = @"routeNative";

@implementation TempoTestPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"tempo_test"
            binaryMessenger:[registrar messenger]];
  TempoTestPlugin* instance = [[TempoTestPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([kGetPlatformVersion isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  } else if ([kGetAppVersion isEqualToString:call.method]) {
    result([[[NSBundle mainBundle]infoDictionary]valueForKey:@"CFBundleShortVersionString"]);
  } else if ([kRouteNative isEqualToString:call.method]) {
    if (call.arguments) {
          NSString *className = [NSString stringWithFormat:@"%@ViewController",call.arguments];
          Class cls = NSClassFromString(className);          
          if (cls) {
              UINavigationController *nav = [[UINavigationController alloc]initWithRootViewController:[[cls alloc]init]];
              [[UIApplication sharedApplication].delegate.window.rootViewController presentViewController:nav animated:YES completion:nil];
              result(@(1));
              return;
          }
      }
      result(@(0));
  } else {
    result(FlutterMethodNotImplemented);
  }
}

@end
